//This file contains object definitions for use with the HRM
//Originally written by Matt Johnson (1999)
//Updated by Lou Mariano (2000)


#include<assert.h>

template<class Type>
class Mat{
public:
  Mat(){}//Default Mat Constructor
  ~Mat(){//Mat Destructor
  }

	Type *elem;
	void Mat2(int nr,int nc){
		nrow=nr;
		ncol=nc;
		elem=new Type[nrow*ncol];
		assert(elem!=0);
	}
	Type GetElem(int r,int c){return(elem[ncol*r+c]);}
	void SetElem(int r,int c,Type val){
		elem[ncol*r+c]=val;
	}
	void GetRow(int r,Type vec[]){
		for(int j=0;j<ncol;j++){
			vec[j]=elem[r*ncol+j];
		}
	}
	void GetColumn(int c,Type vec[]){
		for(int i=0;i<nrow;i++){
			vec[i]=elem[i*ncol+c];
		}
	}
	
  void FreeMat2(){
    delete [] elem;
  }

private:
	int nrow;
	int ncol;
};



class Resp{
public: 
  Resp(){} //Default Resp Constructor
  ~Resp(){// Resp Destructor
    delete raters;
    delete lat_resp;
  }
	Mat<int> score;
	int *raters;
	int *lat_resp;
	int nquest;	
	int nraters;
	void SetPar(int nq,int nr){
		nquest=nq;
		nraters=nr;
		raters=new int[nraters];
		score.Mat2(nq,nr);
		lat_resp=new int[nquest];
	}
	void SetRater(int nrater, int vec[]){
		for(int i=0;i<nrater;i++){
			raters[i]=vec[i];
		}
	}
	void SetScore(int q,int r,int val){
		score.SetElem(q,r,val);
	}
};






class Quest{
public:
  Quest(){}//Default Quest Constructor
  ~Quest(){//Quest Destructor
  }
	int ncat;
	double *gamma;
	double beta;
	void SetBeta(double nbeta){beta=nbeta;}
	void SetGamma(double ngam[]){
		gamma[ncat-2]=0;
		for(int i=0;i<ncat-2;i++){
			gamma[i]=ngam[i];
			gamma[ncat-2] -= gamma[i];
		}
	}
	void SetNcat(int n){
		ncat=n;
		gamma = new double[ncat-1];
		assert(gamma!=0);
	}
  void FreeNcat(){
    delete [] gamma;
  }
};




