// This function calculates the probabilities according to 
// the partial credit model.
// Written by Matt Johnson (1999)


#include<math.h>
#include<iostream.h>
#include "PCM.hpp"

void cumsum(int dim,double gamma[],double eta[]);

void pcm (Quest task,double theta,double prob[]){
  double phi[task.ncat],eta[task.ncat-1];
  double sum=0;
  cumsum(task.ncat-1,task.gamma,eta);
  phi[0]=1.0;
  sum=phi[0];
  for(int i=1;i<task.ncat;i++){
    phi[i]=exp(i*(theta-task.beta)-eta[i-1]);
    sum += phi[i];
  }
  for(int i=0;i<task.ncat;i++){
    prob[i]=phi[i]/sum;
  }
}

void cumsum(int dim,double gamma[],double eta[]){
  for(int i=0;i<dim;i++){
    eta[i]=0;
    for(int j=0;j<i+1;j++){eta[i]+=gamma[j];}
  }
}
    
    
  
